#include "CameraUtils.hh"

glow::camera::ray glow::camera::getViewRay(glow::camera::CameraBase const& cam, glm::vec2 const& mousePosition)
{
    glm::vec3 ps[2];
    auto i = 0;
    for (auto d : {0.5f, -0.5f})
    {
        glm::vec4 v{mousePosition.x * 2 - 1, 1 - mousePosition.y * 2, d * 2 - 1, 1.0};

        v = glm::inverse(cam.getProjectionMatrix()) * v;
        v /= v.w;
        v = glm::inverse(cam.getViewMatrix()) * v;
        ps[i++] = glm::vec3(v);
    }

    return ray{cam.getPosition(), normalize(ps[0] - ps[1])};
}

glm::mat4 glow::camera::getReversedZInfiniteProjection(float horizontalFov, float aspectRatio, float nearPlane)
{
    float f = 1.0f / tan(glm::radians(horizontalFov) / 2.0f);
    return glm::mat4(f / aspectRatio, 0.0f, 0.0f, 0.0f, 0.0f, f, 0.0f, 0.0f, 0.0f, 0.0f, 0.0f, -1.0f, 0.0f, 0.0f, nearPlane, 0.0f);
}
