#include "TargetOrbitController.hh"

#include <glow/common/log.hh>

#include <GLFW/glfw3.h>

void glow::camera::TargetOrbitController::update(float, const glow::input::InputState& input, glow::camera::SmoothedCamera& camera) const
{
    if (input.isMouseButtonDown(GLFW_MOUSE_BUTTON_LEFT))
    {
        float dX = input.getMouseDeltaF().x / camera.getViewportWidth() * mCameraOrbitSpeed;
        float dY = input.getMouseDeltaF().y / camera.getViewportHeight() * mCameraOrbitSpeed;

        if (std::abs(dX) + std::abs(dY) > .0005f)
            camera.handle.orbit(dX, dY);
    }

    auto const& scrollY = input.getScrollDelta().y;
    if (std::abs(scrollY) > 0.f)
    {
        camera.handle.addTargetDistance(-scrollY * 0.1f);
    }
}
