#pragma once

#include <glm/glm.hpp>

#include <glow/common/shared.hh>
#include <glow/std140.hh>

namespace glow
{
namespace pipeline
{
struct Light
{
    glm::vec4 posASize;    ///< Vec3 (Pos A) + float (Size)
    glm::vec4 posBRadius;  ///< Vec3 (Pos B) + float (Radius)
    glm::vec4 colorMaskId; ///< Vec3 (Color) + int (Mask ID)

    /// Tube light
    Light(glm::vec3 const& posA, glm::vec3 const& posB, glm::vec3 const& color, float size, float radius, int maskId = 0)
      : posASize{posA, size}, posBRadius{posB, radius}, colorMaskId{color, maskId}
    {
    }

    /// Sphere light
    Light(glm::vec3 const& pos, glm::vec3 const& color, float size, float radius, int maskId = 0)
      : posASize{pos, size}, posBRadius{pos, radius}, colorMaskId{color, maskId}
    {
    }

    /// Point light
    Light(glm::vec3 const& pos, glm::vec3 const& color, float radius, int maskId = 0)
      : posASize{pos, 0.f}, posBRadius{pos, radius}, colorMaskId{color, maskId}
    {
    }
};
}
}
