#pragma once

#include <string>

#include <glow/common/non_copyable.hh>

namespace nvg
{
struct NVGcontext;
}

namespace glow
{
namespace vector
{
struct image2D;

class OGLRenderer
{
    GLOW_NON_COPYABLE(OGLRenderer);

public:
    OGLRenderer() = default;
    ~OGLRenderer();

    /// renders the image to the current bound framebuffer
    /// NOTE: must have stencil buffer!
    void render(image2D const& img, int w, int h, float devicePixelRatio = 1.0f) const;

    /// loads a font and makes it available under "name"
    void loadFont(std::string const& name, std::string const& file);

private:
    void lazy_init() const;

    mutable nvg::NVGcontext* vg = nullptr;
};
}
}
