#include "Scene.hh"

#include "renderables/Renderable.hh"

using namespace glow;
using namespace glow::viewer;

SharedScene Scene::add(const SharedRenderable &r)
{
    mRenderables.push_back(r);
    return shared_from_this();
}

SharedScene Scene::add(const SharedLight &l)
{
    mLights.push_back(l);
    return shared_from_this();
}

aabb Scene::computeAabb() const
{
    aabb bounds;
    for (auto const &r : mRenderables)
        bounds.add(r->computeAabb());
    return bounds;
}

Scene::Scene() {}

SharedScene Scene::create()
{
    return std::make_shared<Scene>();
}
