#include "ViewRenderContext.hh"

#include <glow/objects/Program.hh>

#include <glow-extras/pipeline/RenderCallback.hh>

#include "ViewerApp.hh"

void glow::viewer::ViewRenderContext::setRenderContext(const glow::pipeline::RenderContext* ctx)
{
    render_ctx = ctx;
    render_scene = &ctx->scene;
    render_stage = &ctx->stage;
    render_camera_data = &ctx->camData;
}

glow::UsedProgram glow::viewer::ViewRenderContext::use(const glow::SharedProgram& prog) const
{
    auto shader = render_ctx->useProgram(prog);
    app->prepareShader(prog, shader);
    return shader;
}
