#include "configure.hh"

#include "renderables/GeometricRenderable.hh"
#include "renderables/MeshRenderable.hh"
#include "renderables/PointRenderable.hh"
#include "renderables/Renderable.hh"

namespace glow
{
namespace viewer
{
void configure(const SharedSubView& v, const SharedScene& s, Renderable& r, const glm::mat4& transform)
{
    r.transform(transform);
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, glow::colors::color const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, polymesh::vertex_attribute<glow::colors::color> const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, polymesh::face_attribute<glow::colors::color> const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, polymesh::halfedge_attribute<glow::colors::color> const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, polymesh::edge_attribute<glow::colors::color> const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, std::vector<glow::colors::color> const& c)
{
    r.addAttribute(detail::make_mesh_attribute("aColor", c));
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, ColorMapping const& cm)
{
    r.setColorMapping(cm);
}

void configure(SharedSubView const& v, SharedScene const& s, GeometricRenderable& r, Texturing const& t)
{
    r.setTexturing(t);
}
}
}
