#pragma once

#include <glow/common/shared.hh>

namespace glow
{
namespace viewer
{
namespace detail
{
struct raii_view;
GLOW_SHARED(class, MeshAttribute);
GLOW_SHARED(class, MeshDefinition);
class MeshShaderBuilder;
}

GLOW_SHARED(class, SubView);
GLOW_SHARED(class, ViewRenderer);

GLOW_SHARED(class, Scene);

GLOW_SHARED(class, Layout);
GLOW_SHARED(class, GridLayout);

GLOW_SHARED(class, Renderable);
GLOW_SHARED(class, GeometricRenderable);
GLOW_SHARED(class, MeshRenderable);
GLOW_SHARED(class, PointRenderable);
GLOW_SHARED(class, LineRenderable);

class ColorMapping;
class Texturing;
struct ViewRenderContext;
class ViewerApp;
}

namespace glfw
{
GLOW_SHARED(class, LambdaPipeline);
}

namespace camera
{
GLOW_SHARED(class, SmoothedCamera);
}

namespace pipeline
{
GLOW_SHARED(class, RenderPipeline);
GLOW_SHARED(class, RenderStage);
GLOW_SHARED(class, RenderScene);
GLOW_SHARED(class, StageCamera);
}

namespace colors
{
struct color;
}
}

namespace polymesh
{
class Mesh;

template <class AttrT>
struct vertex_attribute;
template <class AttrT>
struct face_attribute;
template <class AttrT>
struct edge_attribute;
template <class AttrT>
struct halfedge_attribute;
}
