#pragma once

#include "Layout.hh"

#include <glow/common/property.hh>

namespace glow
{
namespace viewer
{
class GridLayout : public Layout
{
private:
    int mColumnCount = -1;
    int mRowCount = -1;
    float mTargetAspectRatio = 1.0f;

public:
    GLOW_PROPERTY(ColumnCount);
    GLOW_PROPERTY(RowCount);

public:
    GridLayout(int cols, int rows, float aspect = 1.0f) : mColumnCount(cols), mRowCount(rows), mTargetAspectRatio(aspect) {}

public:
    void performLayout(SubView& view) const override;
};
}
}
