#include "make_renderable.hh"

namespace glow
{
namespace viewer
{
SharedMeshRenderable make_renderable(builder::PolygonBuilder const& builder)
{
    auto r = MeshRenderable::create(builder);
    r->transform(builder.getTransform());
    return r;
}

SharedPointRenderable make_renderable(builder::PointBuilder const& builder)
{
    auto r = PointRenderable::create(builder);
    r->transform(builder.getTransform());
    return r;
}

SharedLineRenderable make_renderable(builder::LineBuilder const& builder)
{
    auto r = LineRenderable::create(builder);
    r->transform(builder.getTransform());
    return r;
}
} // namespace viewer
} // namespace glow
