#include "Texturing.hh"

using namespace glow;
using namespace glow::viewer;

void Texturing::buildShader(glow::viewer::detail::MeshShaderBuilder &shader) const
{
    shader.addPassthrough(mCoordsAttribute->typeInShader(), "TexCoord");
    shader.addPassthrough("vec4", "Color");

    // TODO: other sampler types
    shader.addUniform("sampler2D", "uTexture");

    shader.addFragmentShaderCode("vColor = texture(uTexture, vTexCoord);");
}

void Texturing::prepareShader(glow::UsedProgram &shader) const
{
    assert(mTexture && "no texture set");
    shader.setTexture("uTexture", mTexture->queryTexture());
}
