#pragma once

#include "GeometricRenderable.hh"

#include "../objects/geometry/LineBuilder.hh"

namespace glow
{
namespace viewer
{
class LineRenderable final : public GeometricRenderable
{
private:
    bool mRoundCaps = false;
    bool mNoCaps = false;
    bool mCameraFacing = false;
    bool mWorldSpaceSize = false;
    bool mExtrapolate = false;

    // is lazily built
    glow::SharedVertexArray mVertexArray;
    glow::SharedProgram mForwardShader;

public:
    aabb computeAabb() override;

    void renderShadow(ViewRenderContext const& ctx, glow::UsedProgram& shader) override;
    void renderDepthPre(ViewRenderContext const& ctx) override;
    void renderForward(ViewRenderContext const& ctx) override;
    void renderTransparent(ViewRenderContext const& ctx) override;

public:
    static SharedLineRenderable create(builder::LineBuilder const& builder);

private:
    void initFromBuilder(builder::LineBuilder const& builder);

    void init() override;
};
}
}
