#pragma once

#include "GeometricRenderable.hh"

#include "../objects/geometry/PolygonBuilder.hh"

namespace glow
{
namespace viewer
{
class MeshRenderable final : public GeometricRenderable
{
private:
    // is lazily built
    glow::SharedVertexArray mMesh;
    glow::SharedProgram mForwardShader;
    glow::SharedProgram mDepthPreShader;
    glow::SharedProgram mShadowShader;

public:
    aabb computeAabb() override;

    void renderShadow(ViewRenderContext const& ctx, glow::UsedProgram& shader) override;
    void renderDepthPre(ViewRenderContext const& ctx) override;
    void renderForward(ViewRenderContext const& ctx) override;
    void renderTransparent(ViewRenderContext const& ctx) override;

public:
    static SharedMeshRenderable create(builder::PolygonBuilder const& builder);

private:
    void init() override;
};
}
}
