#pragma once

#include <functional>

#include <glm/glm.hpp>

#include <glow/fwd.hh>

#include <glow/common/property.hh>
#include <glow/common/shared.hh>
#include <glow/objects/VertexArray.hh>

#include <glow-extras/pipeline/fwd.hh>
#include <glow-extras/pipeline/stages/RenderStage.hh>
#include <glow-extras/pipeline/stages/StageCamera.hh>

#include "../aabb.hh"
#include "../fwd.hh"

namespace glow
{
namespace viewer
{
class Renderable : public std::enable_shared_from_this<Renderable>
{
    // member
private:
    glm::mat4 mTransform;

    // properties
public:
    GLOW_BUILDER(transform, Transform);

    // methods
public:
    virtual void renderShadow(ViewRenderContext const& /*ctx*/, glow::UsedProgram& /*shader*/) {}
    virtual void renderDepthPre(ViewRenderContext const& /*ctx*/) {}
    virtual void renderForward(ViewRenderContext const& /*ctx*/) {}
    virtual void renderTransparent(ViewRenderContext const& /*ctx*/) {}
    virtual void performImgui() {}

    virtual void init() { }

    /// computes the AABB (update min/max)
    virtual aabb computeAabb() = 0;

    // ctor
public:
    virtual ~Renderable() {}
};
}
}
