#include "view.hh"

#include <glow/common/str_utils.hh>
#include <glow/util/DefaultShaderParser.hh>

#include <glow-extras/material/IBL.hh>
#include <glow-extras/pipeline/RenderPipeline.hh>

#ifdef GLOW_EXTRAS_EMBED_SHADERS
#include <glow-extras/generated/viewer_embed_shaders.hh>
#endif

namespace
{
bool _isViewerInitialized = false;
}

std::vector<glow::viewer::SharedSubView> glow::viewer::detail::raii_view::sSubViewStack;

namespace glow
{
namespace viewer
{
glow::SharedTextureCubeMap Viewer::sViewerSkybox;

void Viewer::GlobalInit(SharedTextureCubeMap const &skybox)
{
    if (_isViewerInitialized)
        return;

    material::IBL::GlobalInit();
    pipeline::RenderPipeline::GlobalInit();

    sViewerSkybox = skybox;

#ifdef GLOW_EXTRAS_EMBED_SHADERS
    for (auto &virtualPair : internal_embedded_files::viewer_embed_shaders)
        DefaultShaderParser::addVirtualFile(virtualPair.first, virtualPair.second);
#else
    DefaultShaderParser::addIncludePath(util::pathOf(__FILE__) + "/../../shader");
#endif

    _isViewerInitialized = true;
}
}
}
